// DIOS (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk A
	struct fpos ma[] =
	{
		{ 0x07, 0x01, 0x1000 }, // 3000h`
		{ 0x4e, 0x01, 0x1000 }, // 3000h`
		{ 0x4f, 0x01, 0x1000 }, // 3000h`
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
	// for Disk C
	struct fpos mc[] =
	{
		{ 0x0c, 0x01, 0x0800 }, // 6800h`
		{ 0x0c, 0x09, 0x0800 }, // 
		{ 0x0d, 0x01, 0x0800 }, // 
		{ 0x0d, 0x09, 0x0800 }, // 
		{ 0x0e, 0x01, 0x0800 }, // 
		{ 0x0e, 0x09, 0x0800 }, // 
		{ 0x0f, 0x01, 0x0800 }, // 
		{ 0x0f, 0x09, 0x0800 }, // 
		{ 0x10, 0x01, 0x0800 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// for Disk G
	struct fpos mg[] =
	{
		{ 0x11, 0x01, 0x1000 }, // 3000h`
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA(0x00, 0x00, 0x00, 0x0f, 0x01, buff, 0x200);
		switch (buff[0x100])
		{
		case 'A':
			if (buff[0x00]==0x82)
			{
				printf("Disk A F܂.\n");
				fcut("PROG1",  0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x2f00);
				for (i=0; ma[i].sec; i++)
				{
					sprintf(fname,"MUS1%02d",i);
					fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x01, 0x0000, ma[i].size);
				}
			}
			else if (buff[0x00]==0x81)
			{
				printf("Disk D F܂.\n");
				fcut("ADPCM", 0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x40000);
			}
			continue;

		case 'B':
			printf("Disk B F܂.\n");
			continue;

		case 'C':
			printf("Disk C F܂.\n");
			fcut("PROG2", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x5f00);
			for (i=0; mc[i].sec; i++)
			{
				sprintf(fname,"MUS3%02d",i);
				fcut(fname, mc[i].trk, mc[i].trk>>1, mc[i].trk&1, mc[i].sec, 0x01, 0x0000, mc[i].size);
			}
			continue;

		case 0x04:
			printf("Disk E F܂.\n");
			continue;

		case 0x05:
			printf("Disk F F܂.\n");
			continue;

		case 0x06:
			printf("Disk G F܂.\n");
			for (i=0; mg[i].sec; i++)
			{
				sprintf(fname,"MUS6%02d",i);
				fcut(fname, mg[i].trk, mg[i].trk>>1, mg[i].trk&1, mg[i].sec, 0x01, 0x0000, mg[i].size);
			}
			continue;

		case 0x07:
			printf("Disk H F܂.\n");
			continue;

		case 'U':
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

